import { RRule, RRuleSet, rrulestr } from 'rrule'
import {getHomeUserSchedule1} from '../../api/request'
import { getFormatDate } from '../../utils/utils'
Component({
  mixins: [],
  data: {
    isShowSidebar: '',
    response: [],
    scheduleList: [],
    startPageOnShow: false,
    startYear: '',
    endYear: '',
    isFirstLoad: true
  },
  props: {},
  didMount() {
    let that = this
    let data = {
      startTime:"2020-01-01 00:00:00",
      endTime:"2025-12-30 23:59:59"
    }
    getHomeUserSchedule1(data).then(res => {
      if (res.data.data) {
        this.setData({
          response: res.data.data
        }, () => {
          let now = new Date()
          let year = now.getFullYear();
          let scheduleList = [];
          scheduleList.push(that.returnScheduleList(year - 1))
          scheduleList.push(that.returnScheduleList(year))
          scheduleList.push(that.returnScheduleList(year))
          // 第一次加载
          if (this.data.isFirstLoad) {
            const today = new Date()
            // finalDate 是用来定位到今天的
            const finalDate = new Date(today)
            // finalDate.setDate(today.getDate() - today.getDay())
            that.setData({
              todayStr: finalDate.toLocaleDateString(),
              thisYear: year,
              scheduleList: scheduleList,
              startYear: year - 1,
              endYear: year + 1,
              isFirstLoad: false
            })
          }
        })
      } else {
        console.log('无数据')
      }
    })
  },
  didUpdate() {},
  didUnmount() {},
  methods: {
    changesidebar() {
      let isShowSidebar = this.data.isShowSidebar === '' || this.data.isShowSidebar === false ? true : false
      this.setData({
        isShowSidebar: isShowSidebar
      })
    },
    preventSort() {
      return false
    },
    // 返回删除的日期
    returnExcludeDate(data) {
      let returnData = {
        scheduleList: [],
        templateList: [],
      }
      data.map(item => {
        if(item.length>10) {
          returnData.templateList.push(new Date(item.slice(6,16).replace(/-/g, '/')).getTime())
        } else {
          returnData.scheduleList.push(item)
        }
      })
      return {
        scheduleList: returnData.scheduleList,
        templateList: Math.min(...returnData.templateList)
      }
    },
    // 生成用户时间段内的会议日程并返回会议日程List
    getCalendarList() {
      let that = this
      // 定义map数据结构
      let scheduleMap = new Map()
      // 对规则内的
      this.data.response.templateList.map(item => {
        // TO DO 判断所获取的时间区间
        // 将会议的年，月，日拆分，时分拆分，生成rrules规则
        let terminateTimeList = item.initialTime.split('-') // 
        let startTimeList = item.startTime.split(':')
        let DTSTART = `${terminateTimeList[0]}${terminateTimeList[1]}${terminateTimeList[2]}T${startTimeList[0]}${startTimeList[1]}00Z`
        let rule = RRule.fromString(`${item.recurrenceModel.recurrenceRule};DTSTART=${DTSTART}`)
        // 改变时区
        rule.options.tzid = 'Asia/Hong_Kong'
        // 判断是否需要剔除某一天
        if (item.excludePlanDates) {
          // 拿到剔除日期的list
          let excludeDateList = that.returnExcludeDate(item.excludePlanDates.split(','))
          rule.all().map(item2 => {
            let excludeDate = getFormatDate(item2, 'yyyyMMdd')
            let hasExclude = excludeDateList.scheduleList.indexOf(excludeDate) === -1
            if (new Date(item2).getTime() < excludeDateList.templateList && hasExclude){
              let startTime = getFormatDate(item2, 'yyyyMMdd') + ' ' +  item.recurrenceModel.startTime
              let endTime = new Date(startTime)
              endTime.setMinutes(endTime.getMinutes() + item.recurrenceModel.duration)
              scheduleMap.set(`${new Date(item2).toLocaleDateString()}/${item.id}`, {
                confirmAttendance: item.confirmAttendance,
                endTime: getFormatDate(endTime, 'yyyyMMdd HH:mm:ss'),
                id: item.id,
                startTime: startTime,
                title: item.title,
                planDate: getFormatDate(item2, 'yyyyMMdd')
              })
            }
          })
        } else {
          rule.all().map(item2 => {
            let startTime = getFormatDate(item2, 'yyyyMMdd') + item.recurrenceModel.startTime
            let endTime = new Date(getFormatDate(item2, 'yyyyMMdd') + item.recurrenceModel.startTime)
            endTime.setMinutes(endTime.getMinutes() + item.recurrenceModel.duration)
            scheduleMap.set(`${new Date(item2).toLocaleDateString()}/${item.id}`, {
              confirmAttendance: item.confirmAttendance,
              endTime: getFormatDate(endTime, 'yyyyMMdd HH:mm:ss'),
              id: item.id,
              startTime: startTime,
              title: item.title,
              planDate: getFormatDate(item2, 'yyyyMMdd')
            })
          })
        }
      })
      let scheduleList = []
      this.data.response.scheduleList.map(item => {
        if (!item.scheduleTemplateId) {
          scheduleList.push(item)
        } else if (item.scheduleTemplateId && scheduleMap.get(`${item.planDate.replace(/-/g, '/')}/${item.scheduleTemplateId}`)) {
          scheduleMap.set(`${item.planDate.replace(/-/g, '/')}/${item.scheduleTemplateId}`, item)
        }
      })
      scheduleMap.forEach(function (value, key, map) {
        scheduleList.push(value)
      })
      return scheduleList
    },
    // 生成一年内的渲染数据
    returnScheduleList(year) {
      let that = this
      let calendarList = this.getCalendarList(year)
      let weekList = ['周日', '周一', '周二', '周三', '周四', '周五', '周六']
      let DateMap = new Map();
      let isLeapYear = year % 4 == 0 && year % 100 != 0 || year % 400 == 0
      // 闰年
      if (isLeapYear) {
        let isFirstWeek = false;
        for (let i = 1; i <= 366; i++) {
          // 判断一月第一周的第一个周一
          if (i < 7 && new Date(year, 0, i).getDay() === 0) {
            isFirstWeek = true
          }
          // 是第一个月第一个周一
          if (isFirstWeek) {
            DateMap.set(`${new Date(year, 0, i).toLocaleDateString()}`, {
              scheduleList: []
            })
          }
        }
        // 跨年的那几天不是周一的
        let num = 6 - new Date(year, 0, 366).getDay()
        for (let i = 0; i <= num; i++) {
          DateMap.set(`${new Date(year, 0, 366 + i).toLocaleDateString()}`, {
            scheduleList: []
          })
        }
      } else {
        let isFirstWeek = false;
        for (let i = 1; i <= 365; i++) {
          if (i < 7 && new Date(year, 0, i).getDay() === 0) {
            isFirstWeek = true
          }
          if (isFirstWeek) {
            DateMap.set(`${new Date(year, 0, i).toLocaleDateString()}`, {
              scheduleList: []
            })
          }
        }
        let num = 6 - new Date(year, 0, 365).getDate()
        for (let i = 0; i <= num; i++) {
          DateMap.set(`${new Date(year, 0, 366 + i).toLocaleDateString()}`, {
            scheduleList: []
          })
        }
      }
      // 遍历所有日程
      for (let y = 0; y < calendarList.length; y++) {
        let date1 = calendarList[y].startTime.slice(0, 10).replace(/-/g, '/')
        let date2 = calendarList[y].endTime.slice(0, 10).replace(/-/g, '/')
        let count = this.count(date1, date2)
        // 不跨天
        if (count == 0) {
          // 每年的第一周和跨天的那几天有日程就push进去
          if (DateMap.get(`${new Date(calendarList[y].startTime.replace(/-/g, '/')).toLocaleDateString()}`)) {
            DateMap.get(`${new Date(calendarList[y].startTime.replace(/-/g, '/')).toLocaleDateString()}`).scheduleList.push({
              ...calendarList[y],
              thisDayStartTime: calendarList[y].startTime.slice(11, 16),
              thisDayEndTime: calendarList[y].endTime.slice(11, 16),
              isBeOverdue: new Date().getTime() > new Date(calendarList[y].endTime.replace(/-/g, '/')).getTime() ? true : false
            })
          }
        }
        // 跨天
        else {
          for (let j = 0; j <= count; j++) {
            let time = new Date(date1);
            time.setDate(time.getDate() + j)
            if (DateMap.get(new Date(time.getFullYear(), time.getMonth(), time.getDate()).toLocaleDateString())) {
              DateMap.get(new Date(time.getFullYear(), time.getMonth(), time.getDate()).toLocaleDateString()).scheduleList.push({
                ...calendarList[y],
                isfirstDayOrEndDay: j === 0 ? '0' : j === count ? '2' : '1', // 0 第一天，1中间的天，2结束的天
                thisDayStartTime: calendarList[y].startTime.slice(11, 16),
                thisDayEndTime: calendarList[y].endTime.slice(11, 16),
                isFewDays: j + 1,
                duration: count + 1,
                isBeOverdue: new Date().getTime() > new Date(calendarList[y].endTime.replace(/-/g, '/')).getTime() ? true : false
              })
            }
          }
        }
      }
      let DateList = [];
      let listMonth = '';
      // 第一个月的第一天
      let listWeek = new Date(year, 0, 1).getDay() === 0 ? 0 : 1;
      DateList.push({
        type: 'year',
        value: year
      })
      let thisDay = new Date().toLocaleDateString()
      DateMap.forEach(function (value, key, map) {
        if (new Date(key).getDay() === 0 && that.count(key, new Date(year, 0, isLeapYear ? 366 : 365).toLocaleDateString()) > 7) {
          listWeek = listWeek + 1
          // 有此月份
          if (new Date(key).getMonth() !== listMonth) {
            listMonth = new Date(key).getMonth()
            DateList.push({
              type: 'month',
              value: new Date(key).getMonth() + 1
            })
            let rangeYear1 = new Date(key).getFullYear()
            let rangeMonth1 = new Date(key).getMonth()
            let rangeDay1 = new Date(key).getDate()
            let rangeDate = new Date(rangeYear1, rangeMonth1, rangeDay1 + 6)
            let rangeMonth2 = new Date(rangeDate).getMonth()
            let rangeDay2 = new Date(rangeDate).getDate()
            DateList.push({
              type: 'week',
              value: `第${listWeek}周，${rangeMonth1 + 1}月${rangeDay1}日 - ${rangeMonth2 == rangeMonth1 ? '' : rangeMonth2 + 1 + '月'}${rangeDay2}日`,
              dayStr: key
            })
          }
          // 没有此月份
          else {
            let rangeYear1 = new Date(key).getFullYear()
            let rangeMonth1 = new Date(key).getMonth()
            let rangeDay1 = new Date(key).getDate()
            let rangeDate = new Date(rangeYear1, rangeMonth1, rangeDay1 + 6)
            let rangeMonth2 = new Date(rangeDate).getMonth()
            let rangeDay2 = new Date(rangeDate).getDate()
            DateList.push({
              type: 'week',
              value: `第${listWeek}周，${rangeMonth1 + 1}月${rangeDay1}日 - ${rangeMonth2 == rangeMonth1 ? '' : rangeMonth2 + 1 + '月'}${rangeDay2}日`,
              dayStr: key
            })
          }
        } else if (new Date(key).getDay() === 0 && that.count(new Date(key), new Date(year, 0, isLeapYear ? 366 : 365) < 7)) {
          let rangeYear1 = new Date(key).getFullYear()
          let rangeMonth1 = new Date(key).getMonth()
          let rangeDay1 = new Date(key).getDate()
          let rangeDate = new Date(rangeYear1, rangeMonth1, rangeDay1 + 6)
          let rangeMonth2 = new Date(rangeDate).getMonth()
          let rangeDay2 = new Date(rangeDate).getDate()
          listWeek = 1
          DateList.push({
            type: 'week',
            value: `第${listWeek}周，${rangeMonth1 + 1}月${rangeDay1}日 - ${rangeMonth2 == rangeMonth1 ? '' : rangeMonth2 + 1 + '月'}${rangeDay2}日`,
            dayStr: key
          })
        }
        // 有日程长度 并且不是今天
        if (value.scheduleList.length !== 0 && key !== thisDay) {
          DateList.push({
            type: 'day',
            isThisDay: true,
            value: {
              value: value.scheduleList,
              day: new Date(key).getDate() < 10 ? '0' + new Date(key).getDate() : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()]
            },
          })
        }
        // 有日程长度，并且是今天
        else if (value.scheduleList.length !== 0 && key === thisDay) {
          DateList.push({
            type: 'today',
            value: {
              value: value.scheduleList,
              day: new Date(key).getDate() < 10 ? '0' + new Date(key).getDate() : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()],
              dateStr: key
            },
          })
        }
        if (value.scheduleList.length === 0 && key === thisDay) {
          DateList.push({
            type: 'thisDay',
            value: {
              value: value.scheduleList,
              day: new Date(key).getDate() < 10 ? '0' + new Date(key).getDate() : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()],
              dateStr: key
            },
          })
        }
      });
      return DateList
    },
    // 是否跨天 返回跨天数
    count(date1, date2) {
      var date1 = new Date(date1);
      var date2 = new Date(date2);
      var date = (date2.getTime() - date1.getTime()) / (1000 * 60 * 60 * 24);/*不用考虑闰年否*/
      return date
    }
  }
});
