import create from 'dd-store';
import pageStore from './store';
import { getScheduleDetail, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';

create.Page({
  store: pageStore,
  data: {
    affairList: null, //store,页面用到的变量需要在这里声明
    show: false, //pop
    oldTask: null,
    pop: {
      title: '',
      type: ''
    }
  },
  onLoad(query) {
    this.setData({
      scheduleItem: JSON.parse(query.scheduleItem),
    })
    this.getDetail();
  },
  // 获取详情
  getDetail() {
    let data = {
      id: this.data.scheduleItem.id,
      scheduleTemplateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    getScheduleDetail(data).then(res => {
      if (res.data.code === 0) {
        let participatorList = []
        let originUsers = []
        let participatorUserId = []
        let repeatListMap = new Map()
        for (let value of res.data.data.userList) {
          participatorList.push(value.participator)
          participatorUserId.push(value.participator.userId)
          originUsers.push(value.participator)
        }
        // for (let item of this.data.comListData.repeatList) {
        //   if (item.recurrenceModel.recurrenceModel !== 'weekly') {
        //     repeatListMap.set(item.recurrenceModel.model, item.id)
        //   }
        // }
        // console.log(repeatListMap, 111)
        this.setData({
          confirmAttendance: res.data.data.confirmAttendance,
          organizer: res.data.data.organizer,
          originUsers: originUsers,
          'comListData.meetingWayModelId': res.data.data.meetingWayModel === 'dingtalk' ? 2 : (res.data.data.meetingWayModel === 'zoom' ? 1 : 0),
          'scheduleItem.id': res.data.data.id,
          'scheduleItem.groupId': res.data.data.groupId,
          repeatable: res.data.data.repeatable,
          recurrenceModel: res.data.data.repeatable ? { model: res.data.data.recurrenceModel.model, daysOfMonth: res.data.data.recurrenceModel.daysOfMonth, interval: 1, initialTime: res.data.data.recurrenceModel.initialTime, terminateTime: res.data.data.recurrenceModel.terminateTime, weekDayList: res.data.data.recurrenceModel.weekDayList } : { model: 'no_repeat' },
          originalData: res.data.data,
          title: res.data.data.title,
          remark: res.data.data.remark,
          isShowRemark: res.data.data.remark ? true : false,
          // week: this.data.weekList[new Date(res.data.data.startTime.replace(/'-'/g, "\/")).getDay()]
        })
        // if (res.data.data.repeatable) {
        //   this.setData({
        //     'comListData.comSelectListId': res.data.data.recurrenceModel.model === 'weekly' ? (res.data.data.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(res.data.data.recurrenceModel.model),
        //   })
        // }
        // this.$store.$data.locationName = res.data.data.location.locationName
        // this.$store.$data.roomId = res.data.data.meetingRoomId < 0 ? '' : res.data.data.meetingRoomId
        // this.$store.$data.startTime = res.data.data.startTime.replace(/'-'/g, "\/")
        // this.$store.$data.endTime = res.data.data.endTime.replace(/'-'/g, "\/")
        // this.$store.$data.participatorList = participatorList
        // this.$store.$data.participatorUserId = participatorUserId
        // this.$store.update();
        // this.conflictPeople()
        this.reload(this.data.scheduleItem.id);
      }
    })
  },
  //获取动态列表
  reload(id) {
    getMeetingRoomAffairs(id).then(res => {
      const affairList = res.data.data;
      const newAffairList = affairList.map(it => {
        if (it.logType == '2') {
          if (it.fileView.creatorInfo) {
            it.fileView.creatorInfo = JSON.parse(it.fileView.creatorInfo);
          }
          if (it.fileView.fileInfos) {
            it.fileView.fileInfos = JSON.parse(it.fileView.fileInfos)
          }
          return it
        }
        else if (it.category === '3' && it.taskViewList) {
          it.taskViewList.map(o => {
            if (o.acceptorInfo) {
              o.acceptorInfo = JSON.parse(o.acceptorInfo)
            }
            if (o.creatorInfo) {
              o.creatorInfo = JSON.parse(o.creatorInfo)
            }
            if (o.taskInfos) {
              o.taskInfos = JSON.parse(o.taskInfos)
            }
            return o
          })
          return it
        }
        return it
      })
      this.store.data.affairList = newAffairList;
      //重置
      this.store.data.isNeedReloadList = false;
      this.update();
    })
  },

  showPop(e) {
    this.setData({
      pop: e.target.dataset.pop,
      show: true
    })
  },
  closePop() {
    this.setData({
      show: false
    });

    if (this.data.pop.type == 'updateTask') {

      const { currentTask } = this.store.data;
      const { oldTask } = this.data;

      //添加执行人
      if (!oldTask.acceptorId && currentTask.acceptorId) {
        this.addTaskExcutor();
      }
      ///删除执行人
      else if (oldTask.acceptorId && !currentTask.acceptorId) {
        this.deleteTaskExcutor();
      }
      //修改执行人
      else if ((oldTask.acceptorId && currentTask.acceptorId) && (oldTask.acceptorId !== currentTask.acceptorId)) {
        this.updateTaskExcutor();
      }
      //修改任务标题
      if (currentTask.taskInfos.taskTitle !== oldTask.taskInfos.taskTitle) {
        this.editTaskTitle();
      }
      //修改任务状态
      if (currentTask.taskStatus !== oldTask.taskStatus) {
        this.changeTaskStatus();
      }

      //刷新列表,这里为什么不在promie后执行
      setTimeout(() => {
        console.log(this.store.data.isNeedReloadList)
        if (this.store.data.isNeedReloadList) {
          this.reload(this.data.scheduleItem.id);
        }
      })
    }
  },
  //出现任务弹窗
  showCreateTask(e) {
    //重置
    this.store.data.currentTask = {};
    this.update();
    this.showPop(e)
  },
  //设置修改任务弹框中当前任务
  setCurrentTask(currentTask) {
    this.setData({
      oldTask: JSON.parse(JSON.stringify(currentTask))
    })
    this.store.data.currentTask = currentTask;
    this.update();
  },
  // 添加文件
  addMeetingFile() {
    decodeURI.navagac
  },
  // 文件上传
  addMeetingFile() {
    let data = {
      ddUserId: getApp().globalData.userid,
      type: 'add',
      projectName: 'MING_MEETING'
    }
    uploadPermissions(data).then(res => {
      if (res.data.code === 0) {
        const _that = this
        dd.uploadAttachmentToDingTalk({
          image: { multiple: true, compress: true, max: 9, spaceId: res.data.data },
          space: { spaceId: res.data.data, compress: true, isCopy: 1, max: 9 },
          types: ["photo", "camera", "space"],
          success: (res) => {
            dd.navigateTo({ url: `./../uploadFile/uploadFile?scheduleItem=${JSON.stringify(_that.data.scheduleItem)}&upLoadInfo=${encodeURIComponent(JSON.stringify(res))}` })
          },
          fail: (err) => {
          }
        })
      }
    })
  },
  // 修改文件描述
  updateMeetingFile() {

  },
  // 删除文件
  deleteMeetingFile() {

  },
  // 删除执行人
  deleteTaskExcutor() {
    this.updateTask({
      "logType": "task_remove_acceptor",
      acceptorInfo: JSON.stringify(this.data.oldTask.acceptorInfo),
      acceptorId: this.data.oldTask.acceptorId
    })
  },
  // 添加执行人
  addTaskExcutor() {
    this.updateTask({
      "logType": "task_add_acceptor",
      acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
      acceptorId: this.store.data.currentTask.acceptorId
    })
  },
  //修改执行人
  updateTaskExcutor() {
    this.updateTask({
      "logType": "task_modify_acceptor",
      acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
      acceptorId: this.store.data.currentTask.acceptorId
    })
  },
  //修改任务标题
  editTaskTitle(value) {
    this.updateTask({
      "logType": "task_modify_title",
      "taskInfos": JSON.stringify(this.store.data.currentTask.taskInfos)
    })
  },
  //列表修改任务状态
  changeTaskStatusOnList(task) {
    this.updateTask({
      "logType": "task_status_modify",
      "taskStatus": task.status,
      'id': task.id
    }, () => {
      this.reload(this.data.scheduleItem.id);
    })
  },
  //弹窗修改任务状态
  changeTaskStatus() {
    this.updateTask({
      "logType": "task_status_modify",
      "taskStatus": this.store.data.currentTask.taskStatus
    })
  },
  //删除任务
  deleteTask(id) {
    this.updateTask({
      "logType": "task_remove",
    }, () => {
      this.closePop();
      this.reload(this.data.scheduleItem.id);
    })
  },
  //修改任务
  updateTask(taskData, callBack) {
    const postData = {
      "groupId": this.data.scheduleItem.groupId,
      "scheduleId": this.data.scheduleItem.id,
      "resourceType": "task",
      "creatorId": getApp().globalData.userid,
      "creatorInfo": getApp().globalData.userInfo,
      "id": this.store.data.currentTask.id,
      ...taskData
    }
    updateMeetingTask(postData).then(res => {
      if (res.data.code == 0) {
        if (callBack) {
          callBack();
        } else {
          this.store.data.isNeedReloadList = true;
          this.update();
        }
      }
    })
  },
  //创建任务
  complete() {
    const { currentTask } = this.store.data;
    const postData = {
      "groupId": this.data.scheduleItem.groupId,
      "scheduleId": this.data.scheduleItem.id,
      "resourceType": "task",
      "creatorId": getApp().globalData.userid,
      "creatorInfo": getApp().globalData.userInfo,
      "logType": "task_add",
      "taskInfos": JSON.stringify(currentTask.taskInfos),
      "taskStatus": '0',
      "description": ""
    }
    if (currentTask.acceptorId) {
      postData.acceptorId = currentTask.acceptorId;
      postData.acceptorInfo = JSON.stringify(currentTask.acceptorInfo);
    }
    createMeetingTask(postData).then(res => {
      if (res.data.code == 0) {
        this.reload(this.data.scheduleItem.id);
        this.closePop();
        //重置
        this.store.data.currentTask = {};
        this.update();
      }
    })
  }
});
