import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    scheduleItem: '',
    conflictPeople: [],
    // 传给组件 hList 水平排列  所有数据 comHListData
    comHListData: {
      contactData: [
        { id: 0, text: '钉钉联系人', imageUrl: '../../assests/dingContact.png' },
        { id: 1, text: '手动添加邮箱', imageUrl: '../../assests/emailContact.png' }
      ]
    },
    popupShow: false
  },
  onLoad(event) {
    if (event.scheduleItem) {
      let scheduleItem = JSON.parse(event.scheduleItem)
      this.setData({
        scheduleItem: scheduleItem
      })
    }
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })

    this.conflictPeople()
  },
  // 关闭popup 点击mark
  closePopup() {
    this.setData({
      popupShow: false
    })
  },
  // 出现popup
  showPopup() {
    this.setData({
      popupShow: true
    })
  },
  // 选择完水平 HList 的回调
  selectComHList(event) {
    switch (event.currentTarget.dataset.item.id) {
      case 0:
        this.addParticipator()
        this.setData({
          popupShow: false
        })
        break;
      case 1:
        this.setData({
          popupShow: false
        })
        dd.navigateTo({ url: `./../outLookContact/outLookContact?scheduleItem=${JSON.stringify(this.data.scheduleItem)}` })
        break;
    }
  },
  // 保存信息
  saveInfo() {
    dd.navigateBack({
      delta: 1
    })
  },
  // 添加参会人
  addParticipator() {
    const _that = this
    let require = []
    let select = []
    let outLookConcat = []
    for (let participator of _that.store.data.participatorList) {
      if (participator.platform === 'outlook') {
        outLookConcat.push(participator)
      }
    }
    if (!_that.data.scheduleItem || this.data.organizer === getApp().globalData.userid) {
      select = this.store.data.participatorUserId
      require = [getApp().globalData.userid]
    } else {
      select = []
      require = [...this.store.data.originUsersId]
    }
    select = _that.selectedelRequired(require, select).pickedUsers
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        let participatorList = []
        let participatorUserId = []
        if (!_that.data.scheduleItem || _that.data.organizer === getApp().globalData.userid) {
          participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
          participatorUserId.push(getApp().globalData.userid)
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        } else {
          _that.store.data.originUsers.forEach((item, index) => {
            participatorList.push(item)
            if (item.platform === 'dingtalk') {
              participatorUserId.push(item.userId)
            }
          })
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        }
        participatorList = _that.setArrary(participatorList.concat(outLookConcat))
        participatorUserId = [...new Set(participatorUserId)]
        _that.store.data.participatorList = participatorList
        _that.store.data.participatorUserId = participatorUserId
        _that.update()
        _that.arrayPoor(_that.store.data.originUsers, _that.store.data.participatorList)
        _that.conflictPeople()
        if (true) {
          _that.store.data.originUsers = _that.store.data.participatorList
          _that.store.data.originUsersId = _that.store.data.participatorUserId
          _that.update()
        } else {
          _that.store.data.participatorList = _that.store.data.originUsers
          _that.store.data.participatorUserId = _that.store.data.originUsersId
        }
      },
      fail: function (err) {
      }
    })
  },
  // 数组取差值 原先的数组与现在的比较 增加与减少
  arrayPoor(origin, now) {
    let originMap = new Map()
    let nowMap = new Map()
    let add = []
    let del = []
    for (let x of origin) {
      originMap.set(x.userId, x)
    }
    for (let x of now) {
      nowMap.set(x.userId, x)
      let status1 = originMap.get(x.userId)
      if (!status1) {
        add.push(x)
      }
    }
    for (let x of origin) {
      let status2 = nowMap.get(x.userId)
      if (!status2) {
        del.push(x)
      }
    }
    this.setData({
      addUserList: add,
      deleteUserList: del
    })
  },
  // 删除参会人
  delParticipants(event) {
    let userId = event.target.dataset.userId
    this.store.data.participatorList.forEach((item, index) => {
      if (userId === item.userId) {
        this.store.data.participatorList.splice(index, 1)
        this.update()
        return
      }
    })
    this.store.data.participatorUserId.forEach((item, index) => {
      if (userId === item) {
        this.store.data.participatorUserId.splice(index, 1)
        this.update()
        return
      }
    })
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })
    this.conflictPeople()
  },
  // 数组去重
  setArrary(arr, userId) {
    console.log(arr)
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 会议冲突
  conflictPeople() {
    let userIds = []
    for (let value of this.store.data.participatorList) {
      userIds.push(value.userId)
    }
    let data = {
      startTime: this.store.data.startTime.replace(/\//g, "-"),
      endTime: this.store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        if (!!this.data.scheduleItem) {
          if (res.data.data[value].length > 1) {
            conflictPeople.push(value)
          }
        } else {
          if (res.data.data[value].length > 0) {
            conflictPeople.push(value)
          }
        }

      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  },
  // 已选用户去中去掉必选用户
  selectedelRequired(req, pic) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  }
});
