import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { queryAvailableMeetingRoomByTime, modifySchedule } from './../../api/request'
import { throttle } from './../../utils/utils.js'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    place: '',
    availableMeetingRoom: [],
    scheduleItem: '',
    repeatable: 0,
    // 传递给组件selectPopup 的数据
    conSelectPopupData: {
      showSelectPopup: false,
      selectType: 'common',
      editSaveList: [{ text: '仅保存此会议', id: 'only' }, { text: '保存此次及以后会议', id: 'future' }]
    },
  },
  onLoad(e) {
    if (e.scheduleItem) {
      this.setData({
        repeatable: e.repeatable,
        scheduleItem: JSON.parse(e.scheduleItem)
      })
    }
    dd.setNavigationBar({
      title: '会议地点'
    })
    let that = this
    let data = {
      startTime: this.store.data.startTime.replace(/\//g, "-"),
      endTime: this.store.data.endTime.replace(/\//g, "-")
    }
    queryAvailableMeetingRoomByTime(data).then(res => {
      that.setData({
        availableMeetingRoom: res.data.data
      })
    })
  },
  selectPlace(event) {
    this.store.data.locationName = event.target.dataset.locationName
    this.store.data.roomId = ''
    this.update()
    if (!!this.data.scheduleItem) {
      if (this.data.repeatable) {
        this.setData({
          'conSelectPopupData.showSelectPopup': true
        })
      } else {
        let data = {
          location: {
            longitude: -999,
            latitude: -999,
            locationName: this.store.data.locationName
          },
          meetingRoomId: this.store.data.roomId,
          modifyModel: 'only',
          modifyContent: 'modify_location'
        }
      }
    } else {
      dd.navigateBack({
        delta: 1
      })
    }
  },
  onSelectPopup(event) {
    let data = {
      location: {
        longitude: -999,
        latitude: -999,
        locationName: this.store.data.locationName
      },
      meetingRoomId: this.store.data.roomId,
      modifyModel: event.currentTarget.dataset.item.id,
      modifyContent: 'modify_location'
    }
    this.modifySchedule(data)

  },
  // 保存编辑
  modifySchedule(data) {
    let obj = {
      scheduleId: this.data.scheduleItem.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    modifySchedule(Object.assign(data, obj)).then(res => {
      if (res.data.code === 0) {
        dd.navigateBack({
          delta: 1
        })
      }
    })
  },
  selectMeetingRoom(e) {
    this.store.data.locationName = e.target.dataset.locationName
    this.store.data.roomId = e.target.dataset.locationid
    this.update()
    dd.navigateBack({
      delta: 1
    })
  },
  inputPlace(event) {
    this.setData({
      place: event.detail.value
    })
  },
  toRoomList: throttle(function () {
    dd.navigateTo({ url: `./../meetingRoomList/meetingRoomList` })
  }, 1000)
});
