import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { saveFileInfo, addSchedule, uploadPermissions, previewPermissions } from '../../api/request.js'
import { throttle } from './../../utils/utils.js'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    scheduleItem: '',
    upLoadInfo: '',
    descript: ''
  },
  onLoad(event) {
    let scheduleItem = JSON.parse(event.scheduleItem)
    let upLoadInfo = JSON.parse(decodeURIComponent(event.upLoadInfo))
    this.setData({
      scheduleItem: scheduleItem,
      upLoadInfo: upLoadInfo
    })
    dd.setNavigationBar({
      title: '上传文件'
    })
  },
  onShow() {
  },
  inputDes(event) {
    let value = event.detail.value
    this.setData({
      descript: value
    })

  },
  close(event) {
    let fileId = event.target.dataset.item.fileId
    this.data.upLoadInfo.data.forEach((item, index) => {
      if (item.fileId == fileId) {
        this.data.upLoadInfo.data.splice(index, 1)
        return
      }
    })
    this.setData({
      upLoadInfo: this.data.upLoadInfo
    })
  },
  add() {
    let data = {
      ddUserId: getApp().globalData.userid,
      type: 'add',
      projectName: 'MING_MEETING'
    }
    uploadPermissions(data).then(res => {
      if (res.data.code === 0) {
        const _that = this
        dd.uploadAttachmentToDingTalk({
          image: { multiple: true, compress: true, max: 9, spaceId: res.data.data },
          space: { spaceId: res.data.data, compress: true, isCopy: 1, max: 9 },
          types: ["photo", "camera", "space"],
          success: (res) => {
            _that.data.upLoadInfo.data.push(...res.data)
            _that.setData({
              upLoadInfo: _that.data.upLoadInfo
            })
          },
          fail: (err) => {
          }
        })
      }
    })
  },
  // 文件预览
  preview(event) {
    const _that = this
    let file = event.target.dataset.file
    let data = {
      ddUserId: getApp().globalData.userid,
      type: 'download',
      fileIds: file.fileId,
      projectName: 'MING_MEETING'
    }
    previewPermissions(data).then(res => {
      dd.previewFileInDingTalk({
        corpId: dd.corpId,
        spaceId: res.data.data,
        fileId: file.fileId,
        fileName: file.fileName,
        fileSize: file.fileSize,
        fileType: file.fileType
      })
    })
  },
  // 保存的接口
  saveUpload: throttle(function () {
    let data = {
      resourceType: 'accessory',
      creatorId: '2',
      scheduleId: this.data.scheduleItem.id,
      uploader: getApp().globalData.userid,
      groupId: this.data.scheduleItem.groupId,
      creatorInfo: JSON.stringify({
        userId: getApp().globalData.userid,
        username: getApp().globalData.name,
        headUrl: getApp().globalData.avatar,
        platform: 'dingtalk'
      }),
      thirdStoreTenant: 'dingTalk',
      fileInfos: JSON.stringify(this.data.upLoadInfo.data),
      description: this.data.descript,
      logType: 'schedule_accessory_add'
    }
    saveFileInfo(data).then(res => {
      dd.alert({
        content: JSON.stringify(data)
      })
      dd.navigateBack({
        delta: 1
      })
    })
  }, 1000)
});
